.buildPatch<-function(updatedFn,patchID=format(Sys.Date(),"%y%m%d")){
    patchInstallName<-paste(gcdx.dir,"/Patch/installPatch",patchID,".r",sep="")
    patchName<-paste(gcdx.dir,"/Patch/patch",patchID,".r",sep="")
    cat("\nBuilding patch",patchID,".r install file\n",sep="")
    cat("#Install file for GCDkit 3.00 patch no",patchID,"\n",file=patchInstallName)
    cat("#The patch may be installed by:\n",file=patchInstallName,append=TRUE)
    cat("#   * copying the install file into directory GCDkit/Patch \n",file=patchInstallName,append=TRUE)
    cat("#   * drag & drop of this install file into the R Console \n",file=patchInstallName,append=TRUE)
    cat("#   * manual pasting of the install file content into the R Console (ctrl-C, ctrl-V)\n",file=patchInstallName,append=TRUE)
    cat("\n",file=patchInstallName,append=TRUE)
    cat("patchID<-\"",patchID,"\"\n",sep="",file=patchInstallName,append=TRUE)
    cat("if (file.access(paste(gcdx.dir,\"/Patch/patch\",patchID,\".r\",sep=\"\"), mode = 4)==-1){\n",sep="",file=patchInstallName,append=TRUE)
    cat("cat (\"Installing the file patch\",patchID,\".r\\n\",sep=\"\")\n",file=patchInstallName,append=TRUE)
    cat("patch<-c(","\n",file=patchInstallName,append=TRUE)
    cat("\"#GCDkit 3.00 patch no",patchID,"\",","\n",file=patchInstallName,append=TRUE)
    for (fnName in updatedFn){
        deparsed<-deparse(eval(parse(text=fnName)))
        cat("\"\",\n",sep="",file=patchInstallName,append=TRUE)
        cat("\"#updated function ",fnName,"()\",\n",sep="",file=patchInstallName,append=TRUE)
        cat("\"",fnName,"<-\",",sep="",file=patchInstallName,append=TRUE)
        for (fnLine in deparsed) {
            cat(deparse(fnLine),",\n",file=patchInstallName,append=TRUE)
        }
    }
    #update the about() file 
    fnName<-deparse(about)
    myMonths<-c('January','February','March','April','May','June','July','August','September','October','November','December')
    patchDate<-paste(as.numeric(substr(patchID,5,6))," ", myMonths[as.numeric(substr(patchID,3,4))]," 20", as.numeric(substr(patchID,1,2)),sep="")
    aboutReplacement<-paste("message <- \"GCDkit Win 3.00 patch ",patchID," [",patchDate,"]\\\\n (c) 1999-20",substr(patchID,1,2),sep="")
    deparsed<-sub("message <-[^(]+[0-9c() -]+",aboutReplacement,fnName)
    cat("\"\",\n",sep="",file=patchInstallName,append=TRUE)
    cat("\"#updated function about()\",\n",sep="",file=patchInstallName,append=TRUE)
    cat("\"about<-\",",sep="",file=patchInstallName,append=TRUE)
    for (fnLine in deparsed) {
        cat(deparse(fnLine),",\n",file=patchInstallName,append=TRUE)
    }


    cat("\"#end\")\n",file=patchInstallName,append=TRUE)

    cat("cat(patch,file=\"",patchName,"\",sep=\"\\n\")\n",sep="",file=patchInstallName,append=TRUE)
    cat("source(\"",patchName,"\")\n",sep="",file=patchInstallName,append=TRUE)
    cat("}",file=patchInstallName,append=TRUE)

}
