
#############################################################################
#                                                                           #
#                              Select directory                             #
#                                                                           #
#############################################################################
#fontHeading<-tkfont.create(family="times",size=12,weight="bold",slant="italic")
.tkDirectory<-function(top.frame=NULL,pack=FALSE,width=60,background="gray95",on.leave=function(){},on.select=function(){}){    
    textDir<-tclVar(data.dir)
    frame <- tkframe(top.frame, borderwidth=0, relief="groove")   
    tkconfigure(frame,padx=0,pady=5)
    
    abbrev<-function(width,what){
       x<-nchar(what)
            if (x>width) txt<-paste("...",substring(what,x-width+5,x)) else txt<-substring(paste(what,"                                                                                                        "),1,width)    
        return(txt)
    }
    
    # Successfully selected
    OnFilenameBrowse<-function(dir){
            if(dir=="") return()
            assign("data.dir",dir,env = .GlobalEnv)
            textFilename<-tclVar(dir)
            tkgrid(tklabel(frame,text=abbrev(width,dir),font=fontFileName),sticky="w",row=0,column=2)
    }
    
    # Clicked button for selecting a directory
    OnSelectDir<-function(){
        OnFilenameBrowse(tclvalue(tkchooseDirectory(initialdir=data.dir,title="Select the GCDkit data directory")))
    }
    
    fontFileName<-tkfont.create(family="courier",size=9)#,slant="italic")
    
    #frame2 <- tkframe(top.frame, borderwidth=0, relief="groove") 
        SelectDir.but <-tkbutton(frame,text=" ... ",command=OnSelectDir)
        #fontHeading<-tkfont.create(family="times",size=11,weight="bold",slant="italic")       
        tkgrid(tklabel(frame,text="Working directory ",font=fontHeading,background=background),SelectDir.but,sticky="w")  
    #tkgrid(frame2,sticky="w")
    text<-tclvalue(textDir)
    tkgrid(tklabel(frame,text=abbrev(width,text),font=fontFileName),sticky="w",row=0,column=2)     
    tkbind(frame,"<Leave>",on.leave)     
    tkgrid(frame)
}

#############################################################################
#                                                                           #
#                         Selects a single variable                         #
#                                                                           #
#############################################################################

tkSelectVariable<-function(top.frame=NULL,where=colnames(WR),preselect=2,pack=FALSE,message="Select a variable",background="wheat",variable="x",on.leave=function(){},row=0,column=0,height=15,width=50,buttons=FALSE,state="normal"){    
    if(is.null(top.frame)){
        pack<-TRUE
    }
    ee<-selectSingle.tk(top.frame,where,preselect=preselect,message=message,print=FALSE,empty.ok=FALSE,pack=pack,variable=variable,background=background,on.leave=on.leave,row=row,column=column,height=height,width=width,buttons=buttons,state=state)
    #eval(parse(text=paste("print(",variable,")",sep="")))
}

#############################################################################
#                                                                           #
#                         Selects multiple variables                        #
#                                                                           #
#############################################################################

tkSelectVariables<-function(top.frame=NULL,pack=FALSE,where=colnames(WR),preselect=0:(length(where)-1),background="wheat",message="Select variables",variable="y",on.leave=function(){},row=0,column=0,height=15,width=50,buttons=FALSE){    
    if(is.null(top.frame)){
        pack<-TRUE
    }
    ee<-selectSingle.tk(top.frame,where,message=message,print=FALSE,preselect=preselect,empty.ok=FALSE,pack=pack,variable=variable,background=background,on.leave=on.leave,row=row,column=column,height=height,width=width,selectmode="multiple",buttons=buttons)
    #eval(parse(text=paste("print(",variable,")",sep="")))
}


#############################################################################
#                                                                           #
#                         Selects a single sample                           #
#                                                                           #
#############################################################################

tkSelectSample<-function(top.frame=NULL,pack=FALSE,message="Select sample",variable="Sample",preselect=0,show="SiO2",on.leave=function(){},row=0,column=0,height=15,width=50){    
    if(is.null(top.frame)){
        pack<-TRUE
        #require(tcltk) || stop("tcltk support is absent")
        #top.frame<<-tktoplevel()
        #tkwm.title(top.frame,"Select a sample")
    }
    ee<-selectSingle.tk(top.frame,rownames(WR),message=message,print=FALSE,empty.ok=FALSE,pack=pack,variable=variable,on.leave=on.leave,row=row,column=column,height=height,width=width,show=show,preselect=preselect)
    #eval(parse(text=paste("print(",variable,")",sep="")))
}

#############################################################################
#                                                                           #
#                         Selects a mineral file                            #
#                                                                           #
#############################################################################

tkMineralFile<-function(top.frame=NULL,pack=FALSE,width=40,background="wheat",on.leave=function(){},on.select=function(){},prompt="Mineral file",varname="mins"){    
    textFilename<-tclVar(" ")
    frame <- tkframe(top.frame, borderwidth=0, relief="groove")   
    tkconfigure(frame,padx=1,pady=10)
    
    # Successfully selected mineral file
    OnFilenameBrowse<-function(minfile){
            if(minfile=="") return()
            assign("minfile",minfile,env = .GlobalEnv)
            x<-nchar(minfile)
            if (x >width) txt<-paste("...",substring(minfile,x-width+5,x)) else txt<-substring(paste(minfile,"                            "),1,width)
            textFilename<-tclVar(minfile)
            
            tkgrid(tklabel(frame,text=txt,font=fontFileName),sticky="w",row=1)
            
            mins<-read.table(minfile,fill=TRUE,sep="\t")
            mins<-data.matrix(mins)
            mins[is.na(mins)]<-0
            assign(varname,mins,env = .GlobalEnv)
            tkconfigure(ViewFile.but,state="active")
            assign("mins.bak",mins,env = .GlobalEnv)
            #mins.bak<<-mins
            on.select()
    }
    
    # Clicked button for selecting a file
    OnSelectMineralFile<-function(){
        OnFilenameBrowse(tclvalue(tkgetOpenFile(filetypes="{{GCDkit datafiles} {.data}} {{GCDkit Kd files} {.kd}} {{All files} *}")))
    }
    
    OnViewMineralFile<-function(){
        file.show(minfile)
    }

    frame2 <- tkframe(top.frame, borderwidth=0, relief="groove") 
        SelectFile.but <-tkbutton(frame2,text=" ... ",command=OnSelectMineralFile)
        ViewFile.but <-tkbutton(frame2,text=" View ",command=OnViewMineralFile,disabledforeground="gray",state="disabled")
        #fontHeading<-tkfont.create(family="times",size=11,weight="bold",slant="italic")       
        tkgrid(SelectFile.but,tklabel(frame2,text=paste(prompt," "),font=fontHeading,background=background),ViewFile.but,sticky="w")  
    tkgrid(frame2,sticky="n")
    
    fontFileName<-tkfont.create(family="times",size=9,slant="italic")
    tkgrid(tklabel(frame,text=tclvalue(textFilename),font=fontFileName),sticky="w",row=1)     
    tkbind(frame,"<Leave>",on.leave)     
    tkgrid(frame)
}
            
###############################################################3#############
#                                                                           #
#                         Select mineral phases                             #
#                                                                           #
#############################################################################
            
tkSelectPhases<-function(top.frame=NULL,pack=FALSE,on.leave=NULL){          
        OnSelectPhases<-function(){
                ee<-numeric(0)
                for(i in 1:nrow(mins.bak)){
                    eval(parse(text=(paste("ee[",i,"] <- as.numeric(tclvalue(cbValue",i,"))",sep=""))))
                } 
                i<-which(ee==1)
                whichmins<-rownames(mins.bak)[i]
                whichelems<-colnames(mins.bak)
                whichelems<<-whichelems
                whichmins<<-whichmins
                assign("mins",mins.bak[whichmins,whichelems],env = .GlobalEnv)
                on.leave()
        }
                tkconfigure(top.frame,padx=1,pady=1)
                lbWhichMins<- tclVar("rownames(mins)")
                
                .tkCheckBoxesMy(top.frame,rownames(mins),lbWhichMins,text="Phases:",ticks=rep(0,nrow(mins)))
                
                tkgrid.configure(top.frame, sticky="nsew")
                tkbind(top.frame,"<Leave>",OnSelectPhases)
                #tkbind(top.frame,"<KeyRelease>",onSelectPhases)
}


###############################################################3#############
#                                                                           #
#                   Select mineral phases proportions                       #
#                                                                           #
#############################################################################
            
tkSelectPhaseProps<-function(top.frame=NULL,pack=FALSE,on.leave=function(){},on.return=function(){},on.keyrelease=function(){}){          
        lbWhichMins<- tclVar("rownames(mins)")
        .tkEntryTextsMy(top.frame,rownames(mins),lbWhichMins,text="Phases (%):",on.return=on.return,on.keyrelease=on.keyrelease)
        tkbind(top.frame,"<Leave>",on.leave)
}


###############################################################3#############
#                                                                           #
#                              Select oxides                                #
#                                                                           #
#############################################################################


tkSelectElements<-function(top.frame=NULL,where=colnames(WR),pack=FALSE,background="wheat",message="Elements for modelling:",variable="whichelems",row=0,column=0,height=8,width=25,preselect=0:(length(where)-1),selectmode="multiple"){    
    listBoxEntry<-tclVar("")
    frame.listbox <- tkframe(top.frame, borderwidth=0, relief="groove") 
            tkconfigure(frame.listbox,padx=1,pady=10)
            #fontHeading<-tkfont.create(family="times",size=11,weight="bold",slant="italic")
            tkgrid(tklabel(frame.listbox,text=message,font=fontHeading,background=background),sticky="n")       
        
            tkfocus(frame.listbox)
            #Listbox
            listbox<-.tkListBoxMy(frame.listbox,where,listBoxEntry,text="",selectmode=selectmode,height=height,width=width,preselect=preselect)
            tkfocus(frame.listbox)
            # leaving the whole window
            OnLeave2 <- function(){
                selected<<-""      
                if(!pack) OnSelect()
            }
        
    tkbind(frame.listbox,"<Leave>",OnLeave2)
    
    
    # selecting.....
            OnSelect <- function(){
                xx<-where[as.numeric(tkcurselection(listbox)) + 1]
                names(xx)<-NULL
                
                assign(variable,xx,env = .GlobalEnv)
                if(pack)tkdestroy(top.frame)
            }
            if(pack){
                frame.butt <- tkframe(frame.listbox, borderwidth=1, relief="groove") 
                    Select.but <-tkbutton(frame.butt,text="   Select   ",command=OnSelect,fg="darkgreen")
                    tkgrid(Select.but,sticky="w")
                tkgrid(frame.butt)
            }
 tkgrid(frame.listbox,sticky="w")            
}


###############################################################3#############
#                                                                           #
#                         Selects a single variable                         #
#                                                                           #
#############################################################################

selectSingle.tk<-function(top.frame=tt,where=rownames(WR),message="Select sample",preselect=2,default="",silent=FALSE,print=TRUE,empty.ok=TRUE,pack=TRUE,row=0,column=0,variable="xx",selectmode="single",background="wheat",on.leave=NULL,show=NULL,height=15,width=30,buttons=TRUE,state="normal"){
    names(where)<-1:length(where)
    assign(variable,where[preselect],env = .GlobalEnv)
    if(print&!getOption("gcd.shut.up")){
        cat("\n")
        print(where)
        cat("\n")
    }

    # Core function !!!!!!
    .tkSelectColumnMain<-function(where,where.bak,preselect=0,top.frame,background="wheat"){
        on.exit(options("show.error.messages"=TRUE))
        
        # Initialize Tcl variables
        textEntry<-tclVar(selected)
        listBoxEntry<-tclVar("")
        lim1<-tclVar("")
        lim2<-tclVar("")
        tkfocus(top.frame)
        
        main.frame <- tkframe(top.frame,borderwidth=0, relief="groove")
        tkconfigure(main.frame,padx=5,pady=5)
        #fontHeading<-tkfont.create(family="times",size=11,weight="bold",slant="italic")
        fontBody<-tkfont.create(family="times",size=9,weight="bold")
    
        frame.textbox <- tkframe(main.frame, borderwidth=1, relief="groove")
            tkconfigure(frame.textbox,padx=5,pady=5)
            
            # Pressing OK in textbox
            OnReturn <- function(){
                selected<-tclvalue(textEntry)
                assign("selected",selected,env = .GlobalEnv)
                if(selected=="" & length(where)>1){
                    ee<-1:length(where.bak)
                }else{ 
                    ee<-.selectColumnLabel.core(selected,where.bak,empty.ok)
                }
                .tkSelectColumnMain(where.bak[ee],where.bak,preselect=0,top.frame=top.frame,background=background)
            }      
            
                # Entry box
                .tkEntryTexttMy(frame.textbox,textEntry,width=width-nchar(message)+8,text=message,on.return=OnReturn,background=background)
        tkgrid(frame.textbox,row=row,sticky="ew")
        
        frame.listbox <- tkframe(main.frame, borderwidth=0, relief="groove")        
            tkfocus(frame.listbox)
            
            #Listbox
            listbox<-.tkListBoxMy(frame.listbox,where,listBoxEntry,"",selectmode=selectmode,height=height,width=width,preselect=preselect,show=show)
            
            # leaving the whole window, equivalent to Ok button
            OnLeave2 <- function(){
                selected<<-""
                xx<-where[as.numeric(tkcurselection(listbox)) + 1]
                names(xx)<-NULL      
                assign(variable,xx,env = .GlobalEnv)
                on.leave()
            }
        
            #tkbind(frame.listbox,"<Leave>",OnLeave2)
            tkbind(listbox,"<Leave>",OnLeave2)
            tkbind(listbox,"<Return>",OnLeave2)
            tkbind(listbox,"<Button-1>",OnLeave2)
            tkconfigure(listbox,state=state)
            tkfocus(frame.listbox)
            tkgrid(frame.listbox,sticky="we")
            
            # Reset button - lists again all the variables in 'where'
            OnReset <- function(){
                .tkSelectColumnMain(where.bak,where.bak,preselect=0,top.frame=top.frame)
                #selected<<-""
            }
            
            
            # selecting.....
            OnOK <- function(){
                xx<-where[as.numeric(tkcurselection(listbox)) + 1]
                names(xx)<-NULL
                assign(variable,xx,env = .GlobalEnv)
                #if(length(xx)!=0){
                #    .tkSelectColumnMain(xx,where.bak,preselect=0,top.frame=top.frame)
                #}else{ 
                #    .tkSelectColumnMain(where,where.bak,preselect=NULL,top.frame=top.frame)
                #}
                if(pack)tkdestroy(top.frame)
            }
            
            # Cancel button  
            OnCancel <- function(){
                cat("Cancelled....\n")
                flush.console()
                xx<<-""
                selected<<-""
                if(pack)tkdestroy(top.frame)
            }
            
            # Sort up button  
            OnSortUp <- function(){
                where2<-names(sort(WR[where,show],na.last=TRUE))
                .tkSelectColumnMain(where2,where.bak,preselect=0,top.frame=top.frame)
            }    
                        
            # Sort down button  
            OnSortDown <- function(){
                where2<-names(rev(sort(WR[where,show],na.last=TRUE)))
                .tkSelectColumnMain(where2,where.bak,preselect=0,top.frame=top.frame)
            }
            
            if(buttons){
            frame.butt <- tkframe(main.frame, borderwidth=1, relief="groove") 
                Plot.but<-tkbutton(frame.butt,text=" ... ",command=function(){SelectFromPlot("y")},fg="red")
                Reset.but<-tkbutton(frame.butt,text="   Reset   ",command=OnReset)
                SortUp.but<-tkbutton(frame.butt,text=" Sort Up",command=OnSortUp)
                SortDown.but<-tkbutton(frame.butt,text=" Sort Dn ",command=OnSortDown)
                Select.but <-tkbutton(frame.butt,text="   OK   ",command=OnOK,fg="darkgreen")
                Cancel.but <-tkbutton(frame.butt,text="   Cancel   ",command=OnCancel,fg="darkred")
                #if(!pack){
                if(is.null(show)){
                    tkgrid(Plot.but,Reset.but,Select.but,sticky="w")
                }else{
                    tkgrid(Plot.but,Reset.but,SortUp.but,SortDown.but,Select.but,sticky="w")
                }
                #}else{
                #    tkgrid(Plot.but,Reset.but,SortUp.but,SortDown.but,Select.but,Cancel.but,sticky="w")
                #}
            tkgrid(frame.butt)
            }else{
                tkbind(main.frame,"<Leave>",OnOK)
            }
        tkgrid(main.frame,row=row,column=column,sticky="ns") # Draw the whole damn thing
        if(pack & length(where)==1) return()
        tkfocus(top.frame)
        if(pack)tkwait.window(top.frame)
        return()    
    }
    
   if(pack){
        require(tcltk) || stop("tcltk support is absent")
        top.frame<<-tktoplevel()
        tkwm.title(top.frame,"Select a variable")
    }
    xx<<-""
    ee<-.tkSelectColumnMain(where,where,top.frame=top.frame,preselect=preselect,background=background)
    return()
}
        
.selectColumnLabel.core<-function(selected,where=colnames(labels),empty.ok=TRUE,background="wheat",silent=FALSE){ 
    on.exit(options("show.error.messages"=TRUE))
    x<-selected
    #x<-winDialogString(message,default)
    
    if(x==""&empty.ok)return(NULL)
    xx<-gsub("\\*","\\\\*",x)

    if(!is.na(as.numeric(xx))){
        selected<-as.numeric(xx)
        if (selected>length(where)|selected<=0){
            selected<-x
            if(!silent){
                .tkmessageBoxMy(type="ok","Your query produced no matches!")
                options(show.error.messages=FALSE)
                stop("",call. = FALSE)
            }
        }
        return(selected)
    }
            options(show.error.messages=FALSE)
            selected<-try(grep(xx,where))
            if(class(selected)=="try-error"){
                .tkmessageBoxMy(type="ok","Syntax error in search pattern!")
                stop("",call. = FALSE)
            }

    options(show.error.messages=TRUE)
    if(length(selected)==0){
        selected<-x
        if(!silent){
            .tkmessageBoxMy(type="ok","Your query produced no matches!")
            options(show.error.messages=FALSE)
            stop("",call. = FALSE)
            #return(selected)
        }
        options(show.error.messages=TRUE)
        selected.old<-selected
        selected<-gsub("major",paste(major,collapse=","),selected)
        selected<-gsub("REE",paste(REE,collapse=","),selected)
        selected<-gsub("HFSE",paste(HFSE,collapse=","),selected)
        selected<-gsub("LILE",paste(LILE,collapse=","),selected)
        if(selected.old!=selected)selected<-selectColumnLabel(default=selected,silent=TRUE,print=FALSE)
        return(selected)
    }

    if((length(selected)==length(where))&empty.ok){
        selected<-NULL
        return(selected)
    }
    
    
    SelectFromPlot<-function(variable){
    tt<<-tktoplevel()
    tkwm.title(tt,"Binary plot")
    x<<-colnames(WR)[1]
    y<<-colnames(WR)[3]

    frame.xy <- tkframe(tt, borderwidth=3, relief="groove")
                tkconfigure(frame.xy,padx=1,pady=1) 
                #fontHeading<-tkfont.create(family="times",size=11,weight="bold",slant="italic")
                tkgrid(tklabel(frame.xy,text="Elements for plotting:",font=fontHeading,background=background),sticky="n")            
                
                cbLogX<<-tclVar(0)
                cbLogY<<-tclVar(0)
                
                # Select x axis for plot
                frame.x <- tkframe(frame.xy, borderwidth=0, relief="groove") 
                    tkSelectVariable(frame.x,where=colnames(WR),preselect=0,message="x:",variable="x",pack=FALSE,row=0,column=0,width=10,height=5)  
                    .tkCheckBoxMy(frame.x,cbLogX,text="log")
                    print(x)
                # Select y axis for plot
                frame.y <- tkframe(frame.xy, borderwidth=0, relief="groove") 
                    tkSelectVariable(frame.y,where=colnames(WR),preselect=2,message="y:",variable="y",pack=FALSE,row=0,column=1,width=10,height=5)  
                    .tkCheckBoxMy(frame.y,cbLogY,text="log")
                    print(y)
                tkgrid(frame.x,frame.y,sticky="w")
    tkgrid(frame.xy,row=0,column=0)
                
            
    # Buttons
    tkfocus(tt)
    tkwm.deiconify(tt) 
   
    
    # Cancel button  
    OnCancel <- function(){
        cat("Cancelled....\n")
        flush.console()
        tkdestroy(tt)
    }
    
    # OK button
    OnOK<-function(variable){
        print(x)
        print(y)
        windows(width = 6.5, height = 6.5, pointsize = 10)
        plot(WR[,x],WR[,y],xlab=annotate(x),ylab=annotate(y),col=labels$Colour,pch=labels$Symbol)
        #text(WR[,x],WR[,y]+0.15,rownames(WR))
        i<-identify(WR[,x],WR[,y],labels=rownames(WR),n=1,offset=0.1,col="red")
        xx<-rownames(WR)[i]
        assign(variable,xx,env = .GlobalEnv)
        if(length(xx)!=0) .tkSelectColumnMain(xx,where.bak,preselect=0,top.frame=top.frame) else .tkSelectColumnMain(where,where.bak,preselect=NULL,top.frame=top.frame)
        ee<-locator(1)
        ee<-dev.off(dev.cur())
        if(pack)tkdestroy(top.frame)
    }
      
    frame.but<- tkframe(tt, borderwidth=3, relief="groove")
        Cancel.but <-tkbutton(frame.but,text="   Cancel   ",command=OnCancel)
        OK.but <-tkbutton(frame.but,text="   OK   ",command=OnOK)
        tkgrid(Cancel.but,OK.but)
    tkgrid(frame.but,row=1,column=0)
    
    tkfocus(tt)
    ee<-tkwait.window(tt)          
                        
}
    
return(selected)
}


#############################################################################
#                                                                           #
#                             Selects End Members                           #
#                                                                           #
#############################################################################
tkEndMembers<-function(frame=tt,onLeave=function(){},row=1,column=1,daughter=TRUE){    
    frame.endmembers<-tkframe(frame, borderwidth=0, relief="groove")  
        tkbind(frame.endmembers,"<Leave>",onLeave)
        #Parent 
        frame.parent <- tkframe(frame.endmembers, borderwidth=3, relief="groove") 
            tkSelectSample(frame.parent,message="Parent:",variable="Parent",preselect=0,pack=FALSE,row=row,column=column,width=30,height=10)  
        #Daughter 
        if(daughter){
            frame.daughter <- tkframe(frame.endmembers, borderwidth=3, relief="groove") 
                tkSelectSample(frame.daughter,message="Daughter:",variable="Daughter",preselect=1,pack=FALSE,row=row,column=column+1,width=30,height=10)      
            tkgrid(frame.parent,frame.daughter,sticky="w") # Draw
            tkgrid(frame.endmembers,columnspan=2)
        }else{
            tkgrid(frame.parent,sticky="w") # Draw 
            tkgrid(frame.endmembers,sticky="w")
        }
}
       
#############################################################################
#                                                                           #
#                        Select fractionating phases                        #
#                                                                           #
#############################################################################
tkMinerals<-function(frame=tt,on.leave=function(){},row=1,column=1,rowspan=1,columnspan=1){ 
    frame.whichmin <- tkframe(frame, borderwidth=3, relief="groove")
        tkconfigure(frame.whichmin,padx=1,pady=1,width=300)
        tkSelectPhases(frame.whichmin,on.leave=on.leave)
    tkgrid(frame.whichmin,row=row,column=column,sticky="nswe",rowspan=rowspan,columnspan=columnspan)
}   

#############################################################################
#                                                                           #
#                    Select fractionating phases proportions                #
#                                                                           #
#############################################################################
tkMineralProps<-function(frame=tt,on.leave=function(){},on.return=function(){},row=1,column=1,rowspan=1,columnspan=1){    
    fontSum<-tkfont.create(family="symbol",size=12,weight="bold")
    onLeaveProps<<-function(){
        ff<-numeric(0)
        for(i in 1:nrow(mins)){
            eval(parse(text=(paste("ff[",i,"] <- as.numeric(tclvalue(cb",i,"))",sep=""))))
        } 
        names(ff)<-rownames(mins)
        ff<-ff[!is.na(ff)]
        assign("ff",ff,env = .GlobalEnv)
        
        sum<-sum(ff,na.rm=TRUE)
        i<- (sum==100)+2*(sum>100)
        bg<-switch(i+1,
            "gray80",
            "lightgreen",
            "pink"
        )
        sumLab<-tklabel(frame.whichmin,text=paste("S = ",sum,"    "),font=fontSum,background=bg)
        tkgrid(sumLab,sticky="ew",row=1)
        on.leave()
    }
    frame.whichmin <- tkframe(frame, borderwidth=3, relief="groove")
        tkconfigure(frame.whichmin,padx=1,pady=1,width=300)
        tkbind(frame.whichmin,"<Leave>",on.leave)
        sumLab<-tklabel(frame.whichmin,text="S = 0",font=fontSum,background="gray80")
        tkgrid(sumLab,sticky="ew",row=1)
        tkSelectPhaseProps(frame.whichmin,on.leave=onLeaveProps,on.return=onLeaveProps,on.keyrelease=onLeaveProps)
    tkgrid(frame.whichmin,row=row,column=column,sticky="nswe",rowspan=rowspan,columnspan=columnspan)
}         

#############################################################################
#                                                                           #
#                          Select multiple elements                         #
#                                                                           #
#############################################################################
tkElements<-function(whichelems,frame=tt,row=1,column=1,rowspan=1,columnspan=1,text=""){
    frame.whichelems <- tkframe(frame, borderwidth=3, relief="groove")
            tkconfigure(frame.whichelems,padx=1,pady=1)
             if(text!=""){
                #fontHeading<-tkfont.create(family="times",size=11,weight="bold",slant="italic")
                tkgrid(tklabel(frame.whichelems,text=text,font=fontHeading,background="wheat"),sticky="ew",row=0,column=0)
            }
            assign("whichelems",whichelems,env = .GlobalEnv)
            tkSelectElements(frame.whichelems,where=whichelems,pack=FALSE,preselect=0:(length(whichelems)-1))
            assign("whichelems",whichelems,env = .GlobalEnv)
    tkgrid(frame.whichelems,row=row,column=column,sticky="nswe",rowspan=rowspan,columnspan=columnspan)
}          
            
            
#############################################################################
#                                                                           #
#                    Select x axis and y ax[ei]s for plotting               #
#                                                                           #
#############################################################################        
tkXY<-function(frame=tt,row=1,column=1,where=whichelems,text="Elements for plotting:",on.leave=function(){}){
    #fontHeading<-tkfont.create(family="times",size=12,weight="bold",slant="italic")
    xaxis<-where[1]
    yaxis<-where[2]
    tkgrid(tklabel(frame,text=text,font=fontHeading,background="wheat"),sticky="n")
    # Select x axis for plot
    frame.x <- tkframe(frame, borderwidth=0, relief="groove") 
        tkSelectVariable(frame.x,where=where,preselect=0,message="x:",variable="xaxis",pack=FALSE,row=row,column=column,width=10,height=5)  
    # Select y axis for plot
        #tkSelectVariables(frame.x,where=where,message="y:",variable="yaxis",preselect=0,pack=FALSE,row=row,column=column+1,width=10,height=5)  
        tkSelectVariables(frame.x,where=where,message="y:",variable="yaxis",preselect=1:(length(where)-1),pack=FALSE,row=row,column=column+1,width=10,height=5)  
    tkgrid(frame.x,sticky="ew")
}

#############################################################################
#                                                                           #
#                 elect x axis and single y axis for plotting               #
#                                                                           #
#############################################################################        
tkXY1<-function(frame=tt,row=1,column=1,where=whichelems,text="Elements for plotting:",on.leave=function(){}){
    #fontHeading<-tkfont.create(family="times",size=12,weight="bold",slant="italic")
    xaxis<-where[1]
    yaxis<-where[2]
    tkgrid(tklabel(frame,text=text,font=fontHeading,background="wheat"),sticky="n")
    # Select x axis for plot
    frame.x <- tkframe(frame, borderwidth=0, relief="groove") 
        tkSelectVariable(frame.x,where=where,preselect=0,message="x:",variable="xaxis",pack=FALSE,row=row,column=column,width=10,height=5)  
    # Select y axis for plot
        tkSelectVariable(frame.x,where=where,preselect=0,message="y:",variable="yaxis",pack=FALSE,row=row,column=column+1,width=10,height=5)  
        #tkSelectVariables(frame.x,where=where,message="y:",variable="yaxis",preselect=1:(length(where)-1),pack=FALSE,row=row,column=column+1,width=10,height=5)  
    tkgrid(frame.x,sticky="ew")
}     
       
       
       
       
       
       
       
