# Careful, it cannot have trailing zeroes before EOL
.Menu<-function(){
if(.Platform$OS.type=="windows"&.Platform$GUI=="Rgui"){
winMenuAdd("GCDkit")
    winMenuAddItem("GCDkit","Load data file","loadData()")
    winMenuAddItem("GCDkit","Paste data from clipboard","loadData(clipboard=TRUE)")
    winMenuAddItem("GCDkit","Online search EarthChem.org",".EarthChemGUI()")
    winMenuAddItem("GCDkit","Append samples from file","mergeDataRows()")
    winMenuAddItem("GCDkit","Append variables from file","mergeDataCols()")
    winMenuAddItem("GCDkit","Save data file","saveData()")
    winMenuAddItem("GCDkit","Export data table to...",".switch.data.export.format()")
    winMenuAddItem("GCDkit","------------------------------------","none")
    winMenuAddItem("GCDkit","Store the current dataset","pokeDataset()")
    winMenuAddItem("GCDkit","Overplot another dataset","overplotDataset()")
    winMenuAddItem("GCDkit","Underplot another dataset","underplotDataset()")
    winMenuAddItem("GCDkit","Switch/restore a dataset","selectDataset()")
    winMenuAddItem("GCDkit","Purge stored datasets","purgeDatasets(GUI=TRUE)")
    winMenuAddItem("GCDkit","------------------------------------    ","none")
    winMenuAddItem("GCDkit","Save all graphics to PS","psAll();figaroOff()")
    winMenuAddItem("GCDkit","Save all graphics to PDF","pdfAll()")
    winMenuAddItem("GCDkit","Close all graphic windows","graphicsOff();figaroOff()")
    winMenuAddItem("GCDkit","----------------------------------","none")
    winMenuAddItem("GCDkit","Save results","saveResults()")
    winMenuAddItem("GCDkit","Append results to data","addResults(GUI=TRUE)")
    winMenuAddItem("GCDkit","Copy results to clipboard","r2clipboard(results)")
    winMenuAddItem("GCDkit","Export results table to...",".switch.results.export.format()")
    winMenuAddItem("GCDkit","---------------------------------- ","none")
    winMenuAddItem("GCDkit","Options...","gcdOptions()")
    winMenuAddItem("GCDkit","Quiet mode?","setShutUp()")
    winMenuAddItem("GCDkit","----------------------------------- ","none")
    winMenuAddItem("GCDkit","Help","browseURL(paste(gcdx.dir,\"/GCDkit_help/00index.html\",sep=\"\"))")
    #winMenuAddItem("GCDkit","Help","browseURL(paste(\"file:/\",gcdx.dir,\"/GCDkit_help/00index.html\",sep=\"\"))")
    winMenuAddItem("GCDkit","About GCDkit","about()")
    winMenuAddItem("GCDkit","Exit GCDkit","quitGCDkit()")
    
winMenuAdd("Data handling")
    winMenuAddItem("Data handling","Display...",".switch.display()")
    winMenuAddItem("Data handling","Edit...",".switch.edit()")
    winMenuAddItem("Data handling","Select subset by...",".switch.subset()")
    winMenuAddItem("Data handling","Set groups by...",".switch.groups()")
    winMenuAddItem("Data handling","Classify...",".switch.classification(\"classify\")")
        
winMenuAdd("Plot settings")
    winMenuAddItem("Plot settings","Display legend","showLegend(GUI=TRUE)")
    winMenuAddItem("Plot settings","Symbols/colours by groups","assignSymbGroup()")
    winMenuAddItem("Plot settings","-------------------------------------","none")
    winMenuAddItem("Plot settings","SYMBOLS         ","none")
    winMenuAddItem("Plot settings","------------------------------------- ","none")
    winMenuAddItem("Plot settings","Symbols by label","assignSymbLab()")
    winMenuAddItem("Plot settings","Symbols by label - initial letters","assignSymbLett()")
    winMenuAddItem("Plot settings","Uniform symbols","assign1symb()")
    winMenuAddItem("Plot settings","Show available symbols","showSymbols()")
    winMenuAddItem("Plot settings","Set uniform symbol size","setCex()")
    
    winMenuAddItem("Plot settings","-----------------------------------   ","none")
    winMenuAddItem("Plot settings","COLOURS         ","none")
    winMenuAddItem("Plot settings","-------------------------------------    ","none")
    winMenuAddItem("Plot settings","Colours by label","assignColLab()")
    winMenuAddItem("Plot settings","Colours by variable","assignColVar()")
    winMenuAddItem("Plot settings","Uniform colours","assign1col()")
    winMenuAddItem("Plot settings","Show available colours","showColours()")
    winMenuAddItem("Plot settings","Set transparency","setTransparency(GUI=TRUE)")
     

winMenuAdd("Calculations")
    winMenuAddItem("Calculations","Calculate a new variable","x<-calc()")
    winMenuAddItem("Calculations","Add a new variable to a script","customScript()")
    winMenuAddItem("Calculations","Recast to given sum","recast()")
    winMenuAddItem("Calculations","Millications","millications(WR,print=TRUE,save=TRUE)")
    winMenuAddItem("Calculations","------------------------------------","none")
    winMenuAddItem("Calculations","Statistics...",".switch.stats()")
    winMenuAddItem("Calculations","Norms...",".switch.norms()")
    
winMenuAdd("Plots")
    winMenuAddItem("Plots","Binary plot","binary()")
    winMenuAddItem("Plots","Ternary plot","ternary()")
    winMenuAddItem("Plots","3D plot","threeD()")
    winMenuAddItem("Plots","xyz plot with circles","plotWithCircles(ident=getOption(\"gcd.ident\"))")
    winMenuAddItem("Plots","Binary boxplot","binaryBoxplot()")
    winMenuAddItem("Plots","Anomaly plot","peterplot(ident=getOption(\"gcd.ident\"))")
    winMenuAddItem("Plots","-------------------------------------   ","none")
    winMenuAddItem("Plots","Multiple plots...",".switch.multiple()")
    winMenuAddItem("Plots","Multiple plots by groups","figMulti()")
    winMenuAddItem("Plots","Plate of several plots","multiplePerPage();Plate()")
    winMenuAddItem("Plots","Spider plots...",".switch.spider()")
    winMenuAddItem("Plots","Profiler","profiler()")
    winMenuAddItem("Plots","------------------------------------ ","none")
    #winMenuAddItem("Plots","Add a new plot to a script","customPlot()")
    #winMenuAddItem("Plots","------------------------------------","none")
    winMenuAddItem("Plots","Classification...",".switch.classification()")
    winMenuAddItem("Plots","Geotectonic...",".switch.geotectonic()")
    winMenuAddItem("Plots","User defined...",".switch.user()")
        
winMenuAdd("Plot editing")
    winMenuAddItem("Plot editing","Load a graph","figLoad()")
    winMenuAddItem("Plot editing","Save a graph","figSave()")
    winMenuAddItem("Plot editing","Redraw/Reset","figRedraw()")
    winMenuAddItem("Plot editing","-----------------------------------      ","none")
    winMenuAddItem("Plot editing","Edit...","figEdit()")
    winMenuAddItem("Plot editing","Colours...","figColours()")
    winMenuAddItem("Plot editing","Text/Symbols size...","figScale()")
    winMenuAddItem("Plot editing","Text annotations off","figRemove()")
    winMenuAddItem("Plot editing","User defined parameter","figUser()")
    winMenuAddItem("Plot editing","-----------------------------------  ","none")
    winMenuAddItem("Plot editing","Add...","figAdd()")
    winMenuAddItem("Plot editing","Zoom...","figZooming()")
    
    winMenuAddItem("Plot editing","------------------------------------","none")
    winMenuAddItem("Plot editing","Select samples","figSelectSamples()")
    winMenuAddItem("Plot editing","Identify points","figIdentify()")
    winMenuAddItem("Plot editing","Highlight multiple points","highlightSelection()")
    winMenuAddItem("Plot editing","Classify","classify(grp = FALSE, labs = TRUE, source.sheet = FALSE)")
    
    winMenuAddItem("Plot editing","-------------------------------------      ","none")
    winMenuAddItem("Plot editing","Add contours","addContours(GUI=TRUE)")
    winMenuAddItem("Plot editing","Filled contour plot","filledContourFig()")
    #winMenuAddItem("Plot editing","------------------------------------          ","none")
    winMenuAddItem("Plot editing","Edit a plot from a plate","Plate()")
        
winMenuAdd("Plugins")
    winMenuAddItem("Plugins","Empty","none")
  
winMenuAdd("$ConsolePopup/Data table")
    winMenuAddItem("$ConsolePopup/Data table","Save to text file","saveData()")
    winMenuAddItem("$ConsolePopup/Data table","----------------------------------  ","none")
    winMenuAddItem("$ConsolePopup/Data table","Export to HTML","HTMLTableWR()")
    if(R.version$arch!="x86_64"){
        winMenuAddItem("$ConsolePopup/Data table","Export to Excel","excelExport()")
        winMenuAddItem("$ConsolePopup/Data table","Export to Excel 2007","excel2007Export()")
        winMenuAddItem("$ConsolePopup/Data table","Export to Access","accessExport()")
        winMenuAddItem("$ConsolePopup/Data table","Export to DBF","dbfExport()")
    }
winMenuAdd("$ConsolePopup/Results table")
    winMenuAddItem("$ConsolePopup/Results table","Copy to clipboard","r2clipboard(results)")
    winMenuAddItem("$ConsolePopup/Results table","Append to data","addResults(,GUI=TRUE)")
    winMenuAddItem("$ConsolePopup/Results table","----------------------------------","none")
    winMenuAddItem("$ConsolePopup/Results table","Save to text file","saveResults()")
    winMenuAddItem("$ConsolePopup/Results table","----------------------------------  ","none")
    winMenuAddItem("$ConsolePopup/Results table","Export to HTML","HTMLTableResults()")
    if(R.version$arch!="x86_64"){
        winMenuAddItem("$ConsolePopup/Results table","Export to Excel","excelExport(results,transpose=FALSE,dec.places=3)")
        winMenuAddItem("$ConsolePopup/Results table","Export to Excel 2007","excel2007Export(results,transpose=FALSE,dec.places=3)")
        winMenuAddItem("$ConsolePopup/Results table","Export to Access","accessExport(results,transpose=FALSE,dec.places=3)")
        winMenuAddItem("$ConsolePopup/Results table","Export to DBF","dbfExport(results)")
    }
# END OF MENUS DEFINITION
}
}
